diff --git a/src/TopOpeBRep/TopOpeBRep_VPointInterClassifier.cxx b/src/TopOpeBRep/TopOpeBRep_VPointInterClassifier.cxx
index 4b6d414..087e8d5 100644
--- a/src/TopOpeBRep/TopOpeBRep_VPointInterClassifier.cxx
+++ b/src/TopOpeBRep/TopOpeBRep_VPointInterClassifier.cxx
@@ -61,7 +61,7 @@ TopAbs_State TopOpeBRep_VPointInterClassifier::VPointPosition
  const Standard_Integer FaceClassifyIndex,
  TopOpeBRep_PointClassifier& PC,
  const Standard_Boolean AssumeINON,
- const Standard_Real Tol)
+ const Standard_Real theTol3D)
 {
   myState = TopAbs_UNKNOWN;
 
@@ -101,7 +101,7 @@ TopAbs_State TopOpeBRep_VPointInterClassifier::VPointPosition
   TopoDS_Face FF = TopoDS::Face(F);
   TopOpeBRepTool_ShapeTool::AdjustOnPeriodic(FF,u,v);
   gp_Pnt2d p2d(u,v);
-  TopAbs_State statefast = PC.Classify(FF,p2d,Tol);
+  TopAbs_State statefast = PC.Classify(FF, p2d, theTol3D);
   myState = statefast;
   VP.State(myState,FaceClassifyIndex);
 
@@ -109,14 +109,14 @@ TopAbs_State TopOpeBRep_VPointInterClassifier::VPointPosition
   // intersections est sur une frontiere de la face FF (ON)ou dans la face FF (IN)  
   Standard_Integer VPSI = VP.ShapeIndex();
   if (AssumeINON && FaceClassifyIndex == VPSI) {
-    mySlowFaceClassifier.Perform(FF,p2d,Tol);
+    mySlowFaceClassifier.Perform(FF, p2d, theTol3D);
     myState = mySlowFaceClassifier.State();
     if      (myState == TopAbs_ON) {
 //modified by NIZHNY-MKK  Mon Jun 19 11:45:36 2000.BEGIN
       myState = SlowClassifyOnBoundary(VP.Value(), p2d, mySlowFaceClassifier, FF);      
       if(myState == TopAbs_ON) {
 //modified by NIZHNY-MKK  Mon Jun 19 11:45:36 2000.END
-	VP.EdgeON(mySlowFaceClassifier.Edge().Edge(),
+	VP.EdgeON(mySlowFaceClassifier.Edge().GetTopoEdge(),
 		  mySlowFaceClassifier.EdgeParameter(),
 		  FaceClassifyIndex);
       }
@@ -130,14 +130,14 @@ TopAbs_State TopOpeBRep_VPointInterClassifier::VPointPosition
 
   else if (!AssumeINON) {
     if (statefast == TopAbs_OUT || statefast == TopAbs_ON) {
-      mySlowFaceClassifier.Perform(FF,p2d,Tol);
+      mySlowFaceClassifier.Perform(FF, p2d, theTol3D);
       myState = mySlowFaceClassifier.State();
       if      (myState == TopAbs_ON) {
 //modified by NIZHNY-MKK  Mon Jun 19 11:45:36 2000.BEGIN
 	myState = SlowClassifyOnBoundary(VP.Value(), p2d, mySlowFaceClassifier, FF);
 	if(myState == TopAbs_ON) {
 //modified by NIZHNY-MKK  Mon Jun 19 11:45:36 2000.END
-	  VP.EdgeON(mySlowFaceClassifier.Edge().Edge(),
+	  VP.EdgeON(mySlowFaceClassifier.Edge().GetTopoEdge(),
 		    mySlowFaceClassifier.EdgeParameter(),
 		    FaceClassifyIndex);
 	}
@@ -150,7 +150,7 @@ TopAbs_State TopOpeBRep_VPointInterClassifier::VPointPosition
     //modified by NIZNHY-PKV Mon Feb  5 19:04:01 2001 f
     if (statefast == TopAbs_ON || statefast == TopAbs_OUT) {
     //if (statefast == TopAbs_ON) {
-      mySlowFaceClassifier.Perform(FF, p2d, Tol);
+      mySlowFaceClassifier.Perform(FF, p2d, theTol3D);
       myState = mySlowFaceClassifier.State();
       
       if (myState == TopAbs_ON || myState == TopAbs_OUT) {
@@ -158,7 +158,7 @@ TopAbs_State TopOpeBRep_VPointInterClassifier::VPointPosition
       //modified by NIZNHY-PKV Mon Feb  5 19:04:49 2001 t
 	myState = SlowClassifyOnBoundary(VP.Value(), p2d, mySlowFaceClassifier, FF);
 	if(myState==TopAbs_ON) {
-	  VP.EdgeON(mySlowFaceClassifier.Edge().Edge(),
+	  VP.EdgeON(mySlowFaceClassifier.Edge().GetTopoEdge(),
 		    mySlowFaceClassifier.EdgeParameter(),
 		    FaceClassifyIndex);
 	}
@@ -179,7 +179,7 @@ TopAbs_State TopOpeBRep_VPointInterClassifier::VPointPosition
 const TopoDS_Shape& TopOpeBRep_VPointInterClassifier::Edge() const
 {
   if (myState == TopAbs_ON) {
-    const TopoDS_Shape& S = mySlowFaceClassifier.Edge().Edge();
+    const TopoDS_Shape& S = mySlowFaceClassifier.Edge().GetTopoEdge();
     return S;
   }
   else {
@@ -210,7 +210,7 @@ static TopAbs_State SlowClassifyOnBoundary(const gp_Pnt& thePointToClassify,
 					   const TopoDS_Face& theFace) {   
 
   Standard_Real aParameterOnEdge = theSlowClassifier.EdgeParameter();
-  const TopoDS_Edge& anEdge = theSlowClassifier.Edge().Edge();
+  const TopoDS_Edge& anEdge = theSlowClassifier.Edge().GetTopoEdge();
 
   Standard_Real parf, parl;
   Handle(Geom_Curve) anEdgeCurve = BRep_Tool::Curve(anEdge, parf, parl);
@@ -247,6 +247,8 @@ static TopAbs_State SlowClassifyOnBoundary(const gp_Pnt& thePointToClassify,
 	  
       if(!anEdgePCurve.IsNull()) {
 	gp_Pnt2d aPoint2dOnEdge = anEdgePCurve->Value(aParameterOnEdge);
+
+        // Must be 3D-tolerance. But we keep the current value.
 	Standard_Real aTol2d = thePoint2dToClassify.Distance(aPoint2dOnEdge) / 3;
 	theSlowClassifier.Perform(theFace, thePoint2dToClassify, aTol2d);
 	if(theSlowClassifier.State() == TopAbs_IN)
diff --git a/src/TopOpeBRepBuild/TopOpeBRepBuild_Builder1.cxx b/src/TopOpeBRepBuild/TopOpeBRepBuild_Builder1.cxx
index 239b136..5b06dc9 100644
--- a/src/TopOpeBRepBuild/TopOpeBRepBuild_Builder1.cxx
+++ b/src/TopOpeBRepBuild/TopOpeBRepBuild_Builder1.cxx
@@ -20,6 +20,7 @@
 #include <BRepTopAdaptor_FClass2d.hxx>
 #include <Geom2d_Curve.hxx>
 #include <Geom2dAPI_ProjectPointOnCurve.hxx>
+#include <Precision.hxx>
 #include <TColStd_MapOfInteger.hxx>
 #include <TopAbs_Orientation.hxx>
 #include <TopAbs_ShapeEnum.hxx>
@@ -1952,7 +1953,7 @@ static TopAbs_State ClassifyEdgeToFaceByOnePoint(const TopoDS_Edge& E,
 
   C2D -> D0(par, aP2d);
 
-  BRepTopAdaptor_FClass2d FC(F, 1e-7);
+  BRepTopAdaptor_FClass2d FC(F, Precision::Confusion());
   TopAbs_State aState = FC.Perform(aP2d);
 
   return aState;
diff --git a/src/TopOpeBRepBuild/TopOpeBRepBuild_GridSS.cxx b/src/TopOpeBRepBuild/TopOpeBRepBuild_GridSS.cxx
index 09aff15..9a66770 100644
--- a/src/TopOpeBRepBuild/TopOpeBRepBuild_GridSS.cxx
+++ b/src/TopOpeBRepBuild/TopOpeBRepBuild_GridSS.cxx
@@ -17,7 +17,6 @@
 
 #include <BRep_Tool.hxx>
 #include <BRepAdaptor_Surface.hxx>
-#include <BRepClass_Edge.hxx>
 #include <BRepClass_Intersector.hxx>
 #include <BRepTools.hxx>
 #include <ElCLib.hxx>
@@ -77,6 +76,7 @@
 #include <TopOpeBRepTool_ShapeExplorer.hxx>
 #include <TopOpeBRepTool_ShapeTool.hxx>
 #include <TopOpeBRepTool_TOOL.hxx>
+#include <TopClass_GeomEdge.hxx>
 
 #ifdef DRAW
 #include <TopOpeBRepTool_DRAW.hxx>
@@ -1309,8 +1309,6 @@ static Standard_Boolean AreFacesCoincideInArea (const TopoDS_Shape& theBaseFace,
   Standard_Real pLinMin = RealLast();
   Standard_Real tol2d = Precision::PConfusion();
   BRepClass_Intersector anInter;
-  BRepClass_Edge aBCE;
-  aBCE.Face() = aBaseFace;
   Standard_Real maxDist = Max (BRep_Tool::Tolerance(aBaseFace),
                                BRep_Tool::Tolerance(aFace));
 
@@ -1331,8 +1329,9 @@ static Standard_Boolean AreFacesCoincideInArea (const TopoDS_Shape& theBaseFace,
       if (PC.IsNull()) {isError = Standard_True; break;}
       BB.UpdateEdge(aE,PC,aBaseFace,tolE);
     }
-    aBCE.Edge() = aE;
-    anInter.Perform(aLin,pLinMin,tol2d,aBCE);
+
+    TopClass_GeomEdge aGE(aE, BRep_Tool::Surface(aBaseFace), PC, pf, pl);
+    anInter.Perform(aLin, pLinMin, Precision::PConfusion(), aGE);
     if (anInter.IsDone()) {
       Standard_Integer i;
       for (i=1; i <= anInter.NbPoints(); i++) {
diff --git a/src/TopOpeBRepBuild/TopOpeBRepBuild_Tools.cxx b/src/TopOpeBRepBuild/TopOpeBRepBuild_Tools.cxx
index 4ee0bba..5c463f4 100644
--- a/src/TopOpeBRepBuild/TopOpeBRepBuild_Tools.cxx
+++ b/src/TopOpeBRepBuild/TopOpeBRepBuild_Tools.cxx
@@ -481,7 +481,7 @@ void TopOpeBRepBuild_Tools::GetNormalInNearestPoint(const TopoDS_Face& F,
 
   
   gp_Pnt2d aP2d(newU, newV);
-  BRepTopAdaptor_FClass2d FC(F, Precision::PConfusion());
+  BRepTopAdaptor_FClass2d FC(F, Precision::Confusion());
   TopAbs_State aState = FC.Perform(aP2d);
 
   //point out of face: try to go at another direction
diff --git a/src/TopOpeBRepBuild/TopOpeBRepBuild_WireEdgeClassifier.cxx b/src/TopOpeBRepBuild/TopOpeBRepBuild_WireEdgeClassifier.cxx
index 099ef2c..e90a907 100644
--- a/src/TopOpeBRepBuild/TopOpeBRepBuild_WireEdgeClassifier.cxx
+++ b/src/TopOpeBRepBuild/TopOpeBRepBuild_WireEdgeClassifier.cxx
@@ -33,6 +33,7 @@
 #include <TopExp_Explorer.hxx>
 #include <BRep_Tool.hxx>
 #include <Geom2d_Curve.hxx>
+#include <BRepAdaptor_Surface.hxx>
 #include <BRepClass_FaceClassifier.hxx>
 #include <Standard_ProgramError.hxx>
 #include <Geom_Curve.hxx>
@@ -51,6 +52,7 @@
 
 #include <TopOpeBRepBuild_Builder.hxx>
 #include <TopOpeBRepBuild_define.hxx>
+#include <TopClass_GeomEdge.hxx>
 
 #ifdef OCCT_DEBUG
 static TCollection_AsciiString PRODINS("dins ");
@@ -75,7 +77,7 @@ TopOpeBRepBuild_WireEdgeClassifier::TopOpeBRepBuild_WireEdgeClassifier
  const TopOpeBRepBuild_BlockBuilder& BB) :
 TopOpeBRepBuild_CompositeClassifier(BB)
 {
-  myBCEdge.Face() = TopoDS::Face(F);
+  myFace = TopoDS::Face(F);
 }
 
 //=======================================================================
@@ -172,7 +174,7 @@ TopoDS_Shape TopOpeBRepBuild_WireEdgeClassifier::LoopToShape(const Handle(TopOpe
   Bit.Initialize();
   if ( !Bit.More() ) return myShape;
 
-  TopoDS_Shape aLocalShape = myBCEdge.Face();
+  TopoDS_Shape aLocalShape = myFace;
   const TopoDS_Face& F1 = TopoDS::Face(aLocalShape);
 //  const TopoDS_Face& F1 = TopoDS::Face(myBCEdge.Face());
   aLocalShape = F1.EmptyCopied();
@@ -281,11 +283,10 @@ TopAbs_State  TopOpeBRepBuild_WireEdgeClassifier::CompareShapes
       const TopoDS_Edge& E2 = TopoDS::Edge(ex2.Current());
       if (mape1.Contains(E2)) continue;
       
-      const TopoDS_Face& theFace =  myBCEdge.Face();
       BRep_Builder BB; 
 
       // p2d on E2 of B2, E2 not shared by B1
-      TopoDS_Shape aLocalShape = theFace.Oriented(TopAbs_FORWARD);
+      TopoDS_Shape aLocalShape = myFace.Oriented(TopAbs_FORWARD);
       TopoDS_Face ftmp = TopoDS::Face(aLocalShape);
 //      TopoDS_Face ftmp = TopoDS::Face(theFace.Oriented(TopAbs_FORWARD));
       aLocalShape = ftmp.EmptyCopied();
@@ -302,7 +303,7 @@ TopAbs_State  TopOpeBRepBuild_WireEdgeClassifier::CompareShapes
 //      TopoDS_Face F1 = TopoDS::Face(ftmp.EmptyCopied());
       BB.Add(F1,TopoDS::Wire(B1));
 
-      Standard_Real tolF1 = BRep_Tool::Tolerance(F1);
+      const Standard_Real tolF1 = BRep_Tool::Tolerance(F1);
       BRepClass_FaceClassifier Fclass(F1, p2d, tolF1);
       state = Fclass.State();
       return state;
@@ -380,17 +381,16 @@ void  TopOpeBRepBuild_WireEdgeClassifier::ResetShape(const TopoDS_Shape& B)
 void  TopOpeBRepBuild_WireEdgeClassifier::ResetElement(const TopoDS_Shape& EE)
 {
   const TopoDS_Edge& E = TopoDS::Edge(EE);
-  const TopoDS_Face& F = myBCEdge.Face();
   Standard_Real f2,l2,tolpc;Handle(Geom2d_Curve) C2D; //jyl980406+
-  Standard_Boolean haspc = FC2D_HasCurveOnSurface(E,F); //jyl980406+
+  Standard_Boolean haspc = FC2D_HasCurveOnSurface(E, myFace); //jyl980406+
   if (!haspc) { //jyl980406+
-    Standard_Boolean trim3d = Standard_True; C2D = FC2D_CurveOnSurface(E,F,f2,l2,tolpc,trim3d); //jyl980406+
+    Standard_Boolean trim3d = Standard_True; C2D = FC2D_CurveOnSurface(E, myFace, f2, l2, tolpc, trim3d); //jyl980406+
     Standard_Real tolE = BRep_Tool::Tolerance(E); //jyl980406+  
     Standard_Real tol = Max(tolE,tolpc); //jyl980406+
-    BRep_Builder BB; BB.UpdateEdge(E,C2D,F,tol); //jyl980406+
+    BRep_Builder BB; BB.UpdateEdge(E, C2D, myFace, tol); //jyl980406+
   } //jyl980406+
   
-  C2D = FC2D_CurveOnSurface(E,F,f2,l2,tolpc);
+  C2D = FC2D_CurveOnSurface(E, myFace, f2, l2, tolpc);
   if (C2D.IsNull()) throw Standard_ProgramError("WEC : ResetElement");
 
   Standard_Real t = 0.397891143689; Standard_Real par = ((1-t)*f2 + t*l2);
@@ -414,20 +414,22 @@ Standard_Boolean TopOpeBRepBuild_WireEdgeClassifier::CompareElement(const TopoDS
 {
   Standard_Boolean bRet = Standard_True;
   const TopoDS_Edge& E = TopoDS::Edge(EE);
-  const TopoDS_Face& F = myBCEdge.Face();
 
   Standard_Real f2,l2,tolpc;Handle(Geom2d_Curve) C2D; //jyl980402+
-  Standard_Boolean haspc = FC2D_HasCurveOnSurface(E,F); //jyl980402+
+  Standard_Boolean haspc = FC2D_HasCurveOnSurface(E, myFace); //jyl980402+
   if (!haspc) { //jyl980402+
-    Standard_Boolean trim3d = Standard_True; C2D = FC2D_CurveOnSurface(E,F,f2,l2,tolpc,trim3d); //jyl980406+
+    Standard_Boolean trim3d = Standard_True;
+    C2D = FC2D_CurveOnSurface(E, myFace, f2, l2, tolpc, trim3d); //jyl980406+
     // C2D = FC2D_CurveOnSurface(E,F,f2,l2,tolpc,trim3d); //jyl980406-
     Standard_Real tolE = BRep_Tool::Tolerance(E); //jyl980402+  
     Standard_Real tol = Max(tolE,tolpc); //jyl980402+
-    BRep_Builder BB; BB.UpdateEdge(E,C2D,F,tol); //jyl980402+
+    BRep_Builder BB; 
+    BB.UpdateEdge(E, C2D, myFace, tol); //jyl980402+
   } //jyl980402+
+  else
+    C2D = FC2D_CurveOnSurface(E, myFace, f2, l2, tolpc);
 
   if (myFirstCompare) {
-    C2D = FC2D_CurveOnSurface(E,F,f2,l2,tolpc);
     Standard_Real t = 0.33334567; Standard_Real par = ((1-t)*f2 + t*l2);
     gp_Pnt2d p2d = C2D->Value(par);
     
@@ -441,14 +443,12 @@ Standard_Boolean TopOpeBRepBuild_WireEdgeClassifier::CompareElement(const TopoDS
     gp_Vec2d v2d(myPoint2d,p2d);
     gp_Lin2d l2d(myPoint2d,v2d);
     Standard_Real dist = myPoint2d.Distance(p2d);
-    Standard_Real tol2d = Precision::PConfusion(); // NYI : a voir
-    myFPC.Reset(l2d,dist,tol2d);
+    myFPC.Reset(l2d,dist);
     myFirstCompare = Standard_False;
   }
   
-  myBCEdge.Edge() = E;
-  TopAbs_Orientation Eori = E.Orientation();
-  myFPC.Compare(myBCEdge,Eori);
+  TopClass_GeomEdge aGE(E, BRep_Tool::Surface(myFace), C2D, f2, l2);
+  myFPC.Compare(aGE, Precision::PConfusion());
 #ifdef OCCT_DEBUG
 //  TopAbs_State state = myFPC.State();
 #endif
diff --git a/src/TopOpeBRepBuild/TopOpeBRepBuild_WireEdgeClassifier.hxx b/src/TopOpeBRepBuild/TopOpeBRepBuild_WireEdgeClassifier.hxx
index feb7b31..63a2d30 100644
--- a/src/TopOpeBRepBuild/TopOpeBRepBuild_WireEdgeClassifier.hxx
+++ b/src/TopOpeBRepBuild/TopOpeBRepBuild_WireEdgeClassifier.hxx
@@ -23,9 +23,9 @@
 
 #include <Standard_Boolean.hxx>
 #include <gp_Pnt2d.hxx>
-#include <BRepClass_Edge.hxx>
-#include <BRepClass_FacePassiveClassifier.hxx>
+#include <BRepClass_FClass2dOfFClassifier.hxx>
 #include <TopoDS_Shape.hxx>
+#include <TopoDS_Face.hxx>
 #include <TopOpeBRepBuild_CompositeClassifier.hxx>
 #include <TopAbs_State.hxx>
 class TopoDS_Shape;
@@ -88,8 +88,8 @@ private:
 
   Standard_Boolean myFirstCompare;
   gp_Pnt2d myPoint2d;
-  BRepClass_Edge myBCEdge;
-  BRepClass_FacePassiveClassifier myFPC;
+  TopoDS_Face myFace;
+  BRepClass_FClass2dOfFClassifier myFPC;
   TopoDS_Shape myShape;
 
 
diff --git a/src/TopOpeBRepBuild/TopOpeBRepBuild_ffsfs.cxx b/src/TopOpeBRepBuild/TopOpeBRepBuild_ffsfs.cxx
index 21e1082..32e37d6 100644
--- a/src/TopOpeBRepBuild/TopOpeBRepBuild_ffsfs.cxx
+++ b/src/TopOpeBRepBuild/TopOpeBRepBuild_ffsfs.cxx
@@ -96,7 +96,8 @@ static Standard_Integer FUN_getAncestorFsp(TopOpeBRepBuild_Builder& B,TopOpeBRep
       if (!ok) return 0;
       Standard_Real tolf = BRep_Tool::Tolerance(f)*1.e1;
       if (dd > tolf) return 0;
-      Standard_Real  TolClass  = 1e-8; BRepTopAdaptor_FClass2d FClass2d(f,TolClass);
+      Standard_Real  TolClass  = 1e-8;
+      BRepTopAdaptor_FClass2d FClass2d(f,TolClass);
       st = FClass2d.Perform(p2d);
     }
     if (st == TopAbs_IN) {
diff --git a/src/TopOpeBRepTool/TopOpeBRepTool_CLASSI.cxx b/src/TopOpeBRepTool/TopOpeBRepTool_CLASSI.cxx
index 5de0450..fa5977d 100644
--- a/src/TopOpeBRepTool/TopOpeBRepTool_CLASSI.cxx
+++ b/src/TopOpeBRepTool/TopOpeBRepTool_CLASSI.cxx
@@ -257,8 +257,7 @@ Standard_Integer TopOpeBRepTool_CLASSI::Classip2d(const TopoDS_Shape& S1, const
   // recall : ffi1 and ffi2 are built on same face 
   // => ffi1(u1,v1) = ffi2(u1,v1)
   // ----------------------------
-  Standard_Real tol2d2 = TopOpeBRepTool_TOOL::TolUV(ffi2,BRep_Tool::Tolerance(ffi2));
-  BRepClass_FaceClassifier class2(ffi2,p2d1,tol2d2);
+  BRepClass_FaceClassifier class2(ffi2,p2d1,BRep_Tool::Tolerance(ffi2));
   TopAbs_State sta12 = class2.State();
   
   // staffi12 : only if !bnd2dUNK and stabnd2d12!=DIFF
@@ -296,8 +295,7 @@ Standard_Integer TopOpeBRepTool_CLASSI::Classip2d(const TopoDS_Shape& S1, const
     gp_Pnt2d p2d2(u2,v2);
 
     // sta21 : 
-    Standard_Real tol2d1 = TopOpeBRepTool_TOOL::TolUV(ffi1,BRep_Tool::Tolerance(ffi1));
-    BRepClass_FaceClassifier class1(ffi1,p2d2,tol2d1);
+    BRepClass_FaceClassifier class1(ffi1,p2d2,BRep_Tool::Tolerance(ffi1));
     TopAbs_State sta21 = class1.State();
 
     if (bnd2dUNK) {
diff --git a/src/TopOpeBRepTool/TopOpeBRepTool_ShapeClassifier.cxx b/src/TopOpeBRepTool/TopOpeBRepTool_ShapeClassifier.cxx
index a738177..5a997af 100644
--- a/src/TopOpeBRepTool/TopOpeBRepTool_ShapeClassifier.cxx
+++ b/src/TopOpeBRepTool/TopOpeBRepTool_ShapeClassifier.cxx
@@ -19,9 +19,8 @@
 #include <BRepAdaptor_Curve2d.hxx>
 #include <BRepAdaptor_Surface.hxx>
 #include <BRepClass3d_SolidExplorer.hxx>
-#include <BRepClass_Edge.hxx>
 #include <BRepClass_FaceClassifier.hxx>
-#include <BRepClass_FacePassiveClassifier.hxx>
+#include <BRepClass_FClass2dOfFClassifier.hxx>
 #include <BRepTopAdaptor_FClass2d.hxx>
 #include <Geom2d_Curve.hxx>
 #include <Geom_Curve.hxx>
@@ -665,134 +664,4 @@ Standard_Boolean TopOpeBRepTool_ShapeClassifier::HasAvLS() const
 {
   Standard_Boolean hasavls = (myPAvLS) ? (!myPAvLS->IsEmpty()) : Standard_False;
   return hasavls;
-}
-
-#if 0
-//=======================================================================
-//function : FindEdge
-//purpose  : 
-//=======================================================================
-
-void TopOpeBRepTool_ShapeClassifier::FindEdge(const TopoDS_Shape& S)
-{
-  myEdge.Nullify();
-  Standard_Boolean isavs = (! myAvS.IsNull());
-  Standard_Boolean isavls = HasAvLS();
-  Standard_Boolean isav = (isavs || isavls);
-
-  if (S.IsNull()) return;
-  TopAbs_ShapeEnum tS = S.ShapeType();
-
-  TopExp_Explorer eex;
-  if ( ! myFace.IsNull() ) eex.Init(myFace,TopAbs_EDGE);
-  else eex.Init(S,TopAbs_EDGE);
-
-  for(; eex.More(); eex.Next()) {
-    const TopoDS_Edge& E = TopoDS::Edge(eex.Current());
-    if ( isav ) {
-      Standard_Boolean toavoid = Standard_False;
-      if ( isavls ) toavoid = myMapAvS.Contains(E);
-      else if ( isavs )	toavoid = E.IsSame(myAvS);      
-      if ( toavoid ) continue;
-    }
-    else if ( BRep_Tool::Degenerated(E) ) {
-      if ( tS != TopAbs_EDGE ) continue;
-    }
-    myEdge = E;
-    break;
-  }
-}
-
-static Standard_Boolean FindAPointInTheFace
-(const TopoDS_Face& _face,gp_Pnt& APoint,Standard_Real& u,Standard_Real& v) 
-{ 
-  TopoDS_Face face=_face;
-  face.Orientation(TopAbs_FORWARD);
-
-  TopExp_Explorer     faceexplorer;
-  BRepAdaptor_Curve2d c;
-  gp_Vec2d T;
-  gp_Pnt2d P;
-  Standard_Boolean Ok = Standard_False;
-  Standard_Integer nbiter=0;
-  Standard_Real myParamOnEdge = 0.5;
-  do { 
-    nbiter++;
-    if(myParamOnEdge==0.5)  myParamOnEdge = 0.4;
-    else if(myParamOnEdge==0.4)  myParamOnEdge = 0.6; 
-    else if(myParamOnEdge==0.6)  myParamOnEdge = 0.3; 
-    else if(myParamOnEdge==0.3)  myParamOnEdge = 0.7; 
-    else if(myParamOnEdge==0.7)  myParamOnEdge = 0.2; 
-    else if(myParamOnEdge==0.2)  myParamOnEdge = 0.8; 
-    else if(myParamOnEdge==0.8)  myParamOnEdge = 0.1; 
-    else if(myParamOnEdge==0.1)  myParamOnEdge = 0.9;
-    else { myParamOnEdge*=0.5; } 
-    
-    for (faceexplorer.Init(face,TopAbs_EDGE); 
-	 faceexplorer.More(); 
-	 faceexplorer.Next()) {
-      TopoDS_Edge Edge = TopoDS::Edge(faceexplorer.Current());
-      c.Initialize(Edge,face);
-      Standard_Integer nbinterval = c.NbIntervals(GeomAbs_C1); 
-      c.D1((c.LastParameter() - c.FirstParameter()) * myParamOnEdge + c.FirstParameter(),P,T);
-      
-      Standard_Real x=T.X();
-      Standard_Real y=T.Y();
-      //-- cout<<"Param:"<<(c.IntervalFirst() + c.IntervalLast()) * param<<" U:"<<P.X()<<" V:"<<P.Y();
-      //-- cout<<" tguv x:"<<x<<" , y:"<<y<<endl;
-      
-      
-      if(Edge.Orientation() == TopAbs_FORWARD) { 
-	T.SetCoord(-y,x);
-      }
-      else { 
-	T.SetCoord(y,-x);
-      }
-      
-      Standard_Real ParamInit = RealLast();
-      Standard_Real TolInit   = 0.00001;
-      Standard_Boolean APointExist = Standard_False;
-      
-      BRepClass_FacePassiveClassifier FClassifier;
-      
-      T.Normalize();
-      P.SetCoord(P.X()+TolInit*T.X(),P.Y()+TolInit*T.Y());
-      FClassifier.Reset(gp_Lin2d(P,T),ParamInit,RealEpsilon());   //-- Longueur et Tolerance #######
-      
-      TopExp_Explorer otherfaceexplorer;
-      for (otherfaceexplorer.Init(face,TopAbs_EDGE); 
-	   otherfaceexplorer.More(); 
-	   otherfaceexplorer.Next()) {
-	TopoDS_Edge OtherEdge = TopoDS::Edge(otherfaceexplorer.Current());
-	if((OtherEdge.Orientation() == TopAbs_EXTERNAL)) { 
-	}
-	else { 
-	  BRepClass_Edge AEdge(OtherEdge,face);
-	  FClassifier.Compare(AEdge,OtherEdge.Orientation());
-	  if(FClassifier.ClosestIntersection()) { 
-	    //-- cout<<" ---> Edge : "<<FClassifier.Parameter()<<endl;
-	    if(ParamInit > FClassifier.Parameter()) { 
-	      ParamInit = FClassifier.Parameter();
-	      APointExist = Standard_True;
-	    }
-	  }
-	}
-      }
-      if(APointExist) { 
-	ParamInit*=0.5;
-	u = P.X() + ParamInit* T.X();
-	v = P.Y() + ParamInit* T.Y();
-	BRepAdaptor_Surface  s;
-	Standard_Boolean computerestriction = Standard_False;
-	s.Initialize(face,computerestriction);
-	s.D0(u,v,APoint);
-	//-- cout<<" u="<<u<<" v="<<v<<"  -> ("<<APoint.X()<<","<<APoint.Y()<<","<<APoint.Z()<<endl;
-	return(Standard_True);
-      }
-    }
-  }
-  while(nbiter<100);
-  return(Standard_False);
-}
-
-#endif
+}
\ No newline at end of file
diff --git a/src/TopOpeBRepTool/TopOpeBRepTool_face.cxx b/src/TopOpeBRepTool/TopOpeBRepTool_face.cxx
index bd3ba61..cf6ac64 100644
--- a/src/TopOpeBRepTool/TopOpeBRepTool_face.cxx
+++ b/src/TopOpeBRepTool/TopOpeBRepTool_face.cxx
@@ -18,6 +18,7 @@
 #include <BRep_Builder.hxx>
 #include <BRep_Tool.hxx>
 #include <BRepTopAdaptor_FClass2d.hxx>
+#include <gp.hxx>
 #include <Precision.hxx>
 #include <Standard_Failure.hxx>
 #include <TopoDS.hxx>
@@ -69,7 +70,7 @@ Standard_Boolean TopOpeBRepTool_face::Init(const TopoDS_Wire& W, const TopoDS_Fa
   B.NaturalRestriction(fres,Standard_True);
 
   // <myfinite> :
-  BRepTopAdaptor_FClass2d FClass(fres,0.);
+  BRepTopAdaptor_FClass2d FClass(fres, gp::Resolution());
   Standard_Boolean infinite = ( FClass.PerformInfinitePoint() == TopAbs_IN);
   myfinite = !infinite;
 
diff --git a/tests/blend/complex/A3 b/tests/blend/complex/A3
index e75b7d9..95f80f4 100644
--- a/tests/blend/complex/A3
+++ b/tests/blend/complex/A3
@@ -4,6 +4,9 @@
 ## Comment : from original bug PRO4497
 ## ====================================
 
+# Result contains the edge covered by the tolerance
+# of its vertices.
+
 restore [locate_data_file CCH_indushep.rle] s
 tscale s 0 0 0 1000
 explode s e
diff --git a/tests/blend/tolblend_simple/C1 b/tests/blend/tolblend_simple/C1
index 623f013..b01edde 100644
--- a/tests/blend/tolblend_simple/C1
+++ b/tests/blend/tolblend_simple/C1
@@ -14,6 +14,8 @@
 #sewing s t_1 t_5 t2_1 t2_5
 #explode s Sh
 
+puts "TODO OCC29236 All:TEST INCOMPLETE"
+
 restore [locate_data_file CFI_7_c3_fhq.rle] s
 tscale  s 0 0 0 SCALE1 
 explode s e
diff --git a/tests/boolean/bfuse_complex/M7 b/tests/boolean/bfuse_complex/M7
index 6e0fb49..452fa75 100644
--- a/tests/boolean/bfuse_complex/M7
+++ b/tests/boolean/bfuse_complex/M7
@@ -1,6 +1,10 @@
 # Original bug : cts20176
 # Date : 16July98
 
+#Shape a contains vertex with tolerance >50.
+#This vertex covers correspond edge completely.
+
+
 restore [locate_data_file CTO904_cts20176a.rle] a 
 restore [locate_data_file cts20176b.rle] b
 
diff --git a/tests/bugs/heal/bug22919 b/tests/bugs/heal/bug22919
index ac5add3..13e6e4f 100644
--- a/tests/bugs/heal/bug22919
+++ b/tests/bugs/heal/bug22919
@@ -1,4 +1,9 @@
-puts "TODO All: Faulty shapes in variables faulty_1 to faulty_"
+puts "REQUIRED OCC23731 All: Faulty shapes in variables faulty_1 to faulty_1"
+
+# IR-2017-09-07
+# ko2 and ko4 are shells containing two faces (despite ss_2 and ss_4 being single faces).
+# One face in every shell HAS TO be classified as invalid by checkshape (e.g. as
+# not closed, bad orientation etc. - please see explanation in the issue #28211).
 
 puts "========"
 puts "OCC22919"
diff --git a/tests/bugs/modalg_5/bug23625_2 b/tests/bugs/modalg_5/bug23625_2
index 9d9fa86..18228b9 100755
--- a/tests/bugs/modalg_5/bug23625_2
+++ b/tests/bugs/modalg_5/bug23625_2
@@ -15,7 +15,7 @@ fit
 
 reflectlines result a 0 1 0
 
-checkprops result -l 3905.95 
+checkprops result -l 3977.19
 checkshape result 
 checksection result
 
diff --git a/tests/bugs/modalg_6/bug25908 b/tests/bugs/modalg_6/bug25908
index c39131f..081f0db 100755
--- a/tests/bugs/modalg_6/bug25908
+++ b/tests/bugs/modalg_6/bug25908
@@ -20,15 +20,15 @@ compound vl v1l vnl vol vil result
 
 set nbshapes_expected "
 Number of shapes in shape
- VERTEX    : 103
- EDGE      : 52
+ VERTEX    : 59
+ EDGE      : 30
  WIRE      : 0
  FACE      : 0
  SHELL     : 0
  SOLID     : 0
  COMPSOLID : 0
  COMPOUND  : 1
- SHAPE     : 156
+ SHAPE     : 90
 "
 
 checknbshapes result -ref ${nbshapes_expected} -t -m "HLRToShape"
diff --git a/tests/bugs/modalg_6/bug26953_3 b/tests/bugs/modalg_6/bug26953_3
index 7e3d975..a9e5a96 100644
--- a/tests/bugs/modalg_6/bug26953_3
+++ b/tests/bugs/modalg_6/bug26953_3
@@ -17,6 +17,6 @@ baddtools b2
 bfillds
 bbop result 0
 
-checkprops result -s 40.7804
+checkprops result -s 40.9086
 
 checkview -display result -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/bugs/modalg_6/bug28211_1 b/tests/bugs/modalg_6/bug28211_1
new file mode 100644
index 0000000..bba45fb
--- /dev/null
+++ b/tests/bugs/modalg_6/bug28211_1
@@ -0,0 +1,25 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+restore [locate_data_file bug28211_DDJ_BLD1_B_Pos3.brep] a
+
+explode a so
+bclearobjects
+bcleartools
+baddobjects a_1
+baddtools a_2
+bfillds
+
+# FUSE
+bbop result 1
+
+checkshape result
+checknbshapes result -solid 1 -shell 1
+checkprops result -v 13953.1 -s 4096.56
+
+checkview -display result -2d -path ${imagedir}/${test_image}.png
\ No newline at end of file
diff --git a/tests/bugs/modalg_6/bug28211_8 b/tests/bugs/modalg_6/bug28211_8
new file mode 100644
index 0000000..be7431d
--- /dev/null
+++ b/tests/bugs/modalg_6/bug28211_8
@@ -0,0 +1,24 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+restore [locate_data_file bug28211_MHX_VKT_WS_Pos3_source.brep] s
+restore [locate_data_file bug28211_MHX_VKT_WS_Pos3_tool.brep] t
+
+explode s f
+explode t f
+
+bnondestructive 1
+
+# Before the fix, exception in bsection algo was thrown.
+bsection r s_91 t_4
+
+bcut result s t
+
+checknbshapes result -solid 4 -shell 4 -face 105 -wire 105
+
+checkview -display result -2d -path ${imagedir}/${test_image}.png
\ No newline at end of file
diff --git a/tests/bugs/modalg_6/bug28800 b/tests/bugs/modalg_6/bug28800
new file mode 100644
index 0000000..6db6ffb
--- /dev/null
+++ b/tests/bugs/modalg_6/bug28800
@@ -0,0 +1,15 @@
+puts "============"
+puts "OCC28800"
+puts "============"
+puts ""
+###############################
+## The compound of two faces is incorrectly detected as self-interfered
+###############################
+
+restore [locate_data_file bug28800_faces.brep] result
+set bcheck [bopcheck result]
+if {![regexp {This shape seems to be OK.} $bcheck]} {
+    puts "Error: bopcheck failed"
+}
+
+checkview -display result -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/bugs/modalg_7/bug23667 b/tests/bugs/modalg_7/bug23667
index e62c5b9..3425b94 100644
--- a/tests/bugs/modalg_7/bug23667
+++ b/tests/bugs/modalg_7/bug23667
@@ -1,3 +1,5 @@
+puts "REQUIRED All: Faulty shapes in variables faulty_1 to faulty_"
+
 puts "================"
 puts "OCC23667"
 puts "================"
diff --git a/tests/bugs/modalg_7/bug26842_1 b/tests/bugs/modalg_7/bug26842_1
index bfed223..d234b39 100644
--- a/tests/bugs/modalg_7/bug26842_1
+++ b/tests/bugs/modalg_7/bug26842_1
@@ -17,4 +17,11 @@ checksection result
 checknbshapes result -vertex 2 -edge 1
 checkprops result -l 1765.01
 
-checkview -display result -2d -path ${imagedir}/${test_image}.png
+smallview
+don result
+fit
+clear
+display s1
+display result
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/bugs/modalg_7/bug26842_2 b/tests/bugs/modalg_7/bug26842_2
index 5d0178f..634f374 100644
--- a/tests/bugs/modalg_7/bug26842_2
+++ b/tests/bugs/modalg_7/bug26842_2
@@ -10,6 +10,15 @@ puts ""
 # bopsection result does not contain any edges.
 ##################################################
 
+# The main problem is in classifier-algorithm.
+# The intersection curve is found but is rejected
+# by BOP-operation because some intermediate point
+# of this curve is classified as OUT. 
+# Good fix must create adecvate polygon for classification,
+# which will respect the pcurve of the face with some deflection
+# (see method BRepTopAdaptor_FClass2d::Init(...)).
+# Currently, this polygon is wrong. 
+
 restore [locate_data_file bug26842_s2.brep] s2
 restore [locate_data_file bug26842_plane.brep] plane
 
@@ -19,6 +28,13 @@ checkshape result
 checksection result
 
 checknbshapes result -vertex 2 -edge 1
-checkprops result -l 1765.01
+checkprops result -l 3941.88
+
+smallview
+don result
+fit
+clear
+display s2
+display result
 
-checkview -display result -2d -path ${imagedir}/${test_image}.png
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/bugs/modalg_7/bug28764 b/tests/bugs/modalg_7/bug28764
index 2609c4d..e066aec 100644
--- a/tests/bugs/modalg_7/bug28764
+++ b/tests/bugs/modalg_7/bug28764
@@ -20,5 +20,4 @@ set log [bopcurves f_1 f_2 -2d]
 checkview -screenshot -2d -path ${imagedir}/${test_image}.png
 
 regexp {Tolerance Reached=+([-0-9.+eE]+)} ${log} full Toler
-checkreal TolReached $Toler 4.60347250530349e-008 0.0 0.1
-
+checkreal TolReached $Toler 4.60347250530349e-008 1e-7 0.
diff --git a/tests/bugs/modalg_7/bug29204 b/tests/bugs/modalg_7/bug29204
index 8ce39b7..9c05115 100644
--- a/tests/bugs/modalg_7/bug29204
+++ b/tests/bugs/modalg_7/bug29204
@@ -19,7 +19,7 @@ checknbshapes result -solid 1 -shell 1 -face 28 -wire 28 -edge 64 -vertex 36 -sh
 
 set tolres [checkmaxtol result]
 
-if { ${tolres} > 0.001} {
+if { ${tolres} > 0.0011} {
    puts "Error: bad tolerance of result"
 }
 
diff --git a/tests/bugs/moddata_2/bug22746_3 b/tests/bugs/moddata_2/bug22746_3
index aa24416..75035c8 100755
--- a/tests/bugs/moddata_2/bug22746_3
+++ b/tests/bugs/moddata_2/bug22746_3
@@ -6,6 +6,8 @@ puts ""
 # Progress indicator in ShapeHealing
 ###########################################################################
 
+puts "TODO ?OCC28674 ALL: The area of result shape is"
+
 set BugNumber OCC22746
 
 set Min_ListLength 11
diff --git a/tests/bugs/moddata_2/bug299 b/tests/bugs/moddata_2/bug299
index fca2b46..b1ef00c 100755
--- a/tests/bugs/moddata_2/bug299
+++ b/tests/bugs/moddata_2/bug299
@@ -1,5 +1,3 @@
-puts "TODO OCC11111 ALL: OCC299: Error 2"
-
 pload QAcommands
 
 puts "================"
@@ -17,7 +15,7 @@ set ll [llength ${info_result}]
 if { ${ll} < 4 } {
     puts "OCC299: Error 1"
 } else {
-    if { [regexp {IN} $info_result] } {
+    if { [regexp {OUT} $info_result] } {
 	puts "OCC299: OK"
     } else {
 	puts "OCC299: Error 2"
